-- Path

function setup()
  viewer.mode=STANDARD
 
  bp,bd={},{}
  
  ps={
    vec2(50,100),   --    p1
    vec2(400,200),  --    p1 ->
    vec2(50,600),   -- -> p2
    vec2(100,800),  --    p2
    vec2(150,1000), --    p2 ->
    vec2(450,900),  -- -> p3
    vec2(400,700),  --    p3
  }
  sel=0

  parameter.integer("interval",5,100,20,bake)
  bake()
  
  parameter.watch("#bp")
  parameter.watch("cost")
  parameter.watch("bd[#bd]")
  
  cursor=vec2(0,0)
  parameter.number("unit",0,1.0,0,follow)
end

function bake()
  bp,bd,cost=bakeBezierPath(ps,interval)
end

function follow()
  cursor=getPointOnPathFromUnit(bp,bd,unit)
end

function draw()
  background(40, 40, 50)
  strokeWidth(3)
  noFill()
  
  stroke(255, 0, 0)
  for i=1,#ps do
    ellipse(ps[i].x,ps[i].y,20)
  end
  for i=1,#ps-1 do
    line(ps[i].x,ps[i].y,ps[i+1].x,ps[i+1].y)
  end
  if sel>0 then
    stroke(255,0,255)
    ellipse(ps[sel].x,ps[sel].y,30)
  end
  
  stroke(255)
  for i=1,#bp-1 do
    line(bp[i].x,bp[i].y,bp[i+1].x,bp[i+1].y)
  end
  
  ellipse(cursor.x,cursor.y,20)
end

function touched(t)
  if t.state==BEGAN and t.tapCount==2 then
    sel=0
  elseif t.state==BEGAN then
    moved=false
    for i=1,#ps do
      local d=t.pos:dist(ps[i])
      if d<50 then
        sel=i
        return
      end
    end
  elseif t.state==CHANGED and sel>0 then
    local p=ps[sel]
    p.x=p.x+t.delta.x
    p.y=p.y+t.delta.y
    moved=true
  elseif t.state==ENDED and moved then
    bake()
    follow()
    moved=false
  end
end





